﻿Imports System.IO

Public Class Form1
    Dim ImageList1 As System.Windows.Forms.ImageList
    Dim items As String()

    Public Function GetTable() As DataTable
        Dim dt As New DataTable()
        dt.Columns.Add("ID")
        dt.Columns.Add("ImageColumn")
        Dim dr As DataRow
        For count As Integer = 1 To 6
            dr = dt.NewRow()
            dr.ItemArray = New Object() {count}
            dt.Rows.Add(dr)
        Next
        Return dt
    End Function

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Binding TDbGrid to a DataTable
        Dim dt As DataTable = GetTable()
        C1TrueDBGrid1.SetDataBinding(dt, "", False)

        ImageList1 = New ImageList()
        ImageList1.ImageSize = New Size(112, 112)

        ' Populating ImageList
        Dim filePaths As String() = Directory.GetFiles("..\..\Images\")
        For i As Integer = 0 To filePaths.Length - 1
            ImageList1.Images.Add(Image.FromFile(filePaths(i)))
        Next
        ' Adjusting RowHeight
        C1TrueDBGrid1.RowHeight = C1TrueDBGrid1.RowHeight * 3

        ' Populating C1Combo
        items = New String(Me.ImageList1.Images.Count - 1) {}
        For i As Int32 = 0 To Me.ImageList1.Images.Count - 1
            items(i) = "Item " & i.ToString()
        Next
        C1Combo1.DataSource = items

        ' Setting C1Combo properties
        C1Combo1.ItemHeight = 50
        C1Combo1.Splits(0).ColumnCaptionHeight = 1
        C1Combo1.AutoCompletion = True
        C1Combo1.LimitToList = True

        ' Setting C1Combo as Editor of C1TrueDbGrid's Column
        C1TrueDBGrid1.Columns(1).Editor = C1Combo1

        ' To fire FetchStyle event for Grid's DisplayColumn and ComboBox's column.
        C1TrueDBGrid1.Splits(0).DisplayColumns(1).FetchStyle = True
        C1Combo1.Splits(0).DisplayColumns(0).FetchStyle = True

    End Sub

    Private Sub C1Combo1_FetchCellStyle(ByVal sender As Object, ByVal e As C1.Win.C1List.FetchCellStyleEventArgs) Handles C1Combo1.FetchCellStyle
        ' To populate images in C1Combo's Column
        e.CellStyle.ForegroundImage = ImageList1.Images(e.Row)
    End Sub

    Private Sub C1TrueDBGrid1_FetchCellStyle(ByVal sender As Object, ByVal e As C1.Win.C1TrueDBGrid.FetchCellStyleEventArgs) Handles C1TrueDBGrid1.FetchCellStyle
        Dim cellText = C1TrueDBGrid1(e.Row, e.Col)
        If cellText.ToString() = "" Then
            ' To set image in C1TrueDbGrid's Cell
            e.CellStyle.ForegroundImage = ImageList1.Images(e.Row)
        Else
            ' To change image in C1TrueDbGrid's Cell after selecting from given image editor
            Dim editorRowIndex As Integer = items.ToList().IndexOf(cellText.ToString())
            e.CellStyle.ForegroundImage = ImageList1.Images(editorRowIndex)
        End If
    End Sub
End Class
